using Bonsai
using Bonsai: Params
using CodeInfoTools
using HTTP: Stream
using Bonsai: handler_writes
using StructTypes
using Test

struct A2
    data
end

StructTypes.StructType(::Type{A2}) = StructTypes.Struct()

@testset "handler_writes" begin
    app = Bonsai.App()
    app.get("/path") do stream
        Bonsai.write(stream, Headers(header="value"))
        Bonsai.write(stream, Body(x=10))
        Bonsai.write(stream, Body(a=A2(10)))
    end
    h = match(app.paths, Dict(), "GET", ["path"], 1)
    @test length(Bonsai.handler_writes(h.fn)) == 4
end

@testset "handler_reads" begin
    app = Bonsai.App()
    app.get("/path/{id}") do stream
        Bonsai.read(stream, Headers(A2))
        Bonsai.read(stream, Body(A2))
		Bonsai.read(stream, Query(color=String))
        Bonsai.read(stream, Params(id=Int))
    end
    h = match(app.paths, Dict(), "GET", ["path", "1"], 1)
    @test length(Bonsai.handler_reads(h.fn)) == 4
end